from pyglet.gl import *
from pyglet import image
from pyglet import media

import RCollisions

import data

from math import *
from constants import *

import random

class Bullet:
	def __init__(self, badDudes, life, damage, pos, speed):
		self.texture = image.load(data.filepath("shot.png")).texture
	
		glBindTexture(GL_TEXTURE_2D, self.texture.id)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
		
		self.pos = list(pos)
		self.speed = speed
		self.rotation = random.random() * 360
		self.updateTicks = 0
		self.badDudes = badDudes
		self.gunLife = life
		self.damage = damage
		
	def update(self):
		#Collisions
		for badeDude in self.badDudes:
			if RCollisions.pointInRect(self.pos, badeDude.rect):
				badeDude.hit(self.damage)
				return True	
	
		self.pos[0] += self.speed[0]
		self.pos[1] += self.speed[1]
		
		if self.pos[0] < 0 or self.pos[0] > 800 or self.pos[1] < 0 or self.pos[1] > 600:
			return True
		
		self.updateTicks += 1
		
		if self.updateTicks >= self.gunLife:
			return True
		return False
	
	def draw(self):
		glPushMatrix()
		glTranslatef(self.pos[0], self.pos[1], 0)
		glRotatef(self.rotation, 0, 0, 1)
		self.texture.blit(- self.texture.width / 2, - self.texture.height / 2)
		glPopMatrix()	