from pyglet.gl import *
# from OpenGL.GL import *

import random
from constants import *

class Particle:
	def __init__(self, world, pos):
		self.pos = list(pos)
		self.size = 1 + random.random() * 2
		self.alpha = 0.8 + random.random() / 5
		self.colour = random.random() / 10
		self.world = world
	def update(self):
		rand = random.random
		self.alpha -= rand() / 20
		if self.alpha <= 0:
			return True		
		self.size *= 1 + rand() / 40
		self.pos[0] += rand() - 0.5
		self.pos[1] += rand() - 0.5 + self.world.speed
		#self.pos[3] += random.random() * 2
		return False
	
	def draw(self):
		glColor4f(self.colour, self.colour, self.colour, self.alpha)
		glPointSize(self.size)
		glBegin(GL_POINTS)
		glVertex2f(self.pos[0], self.pos[1])
		glEnd()
	
class Smoke:
	def __init__(self, world, pos):
		self.particles = []
		for i in range(5 + random.randrange(10)):
			self.particles.append(Particle(world, pos))
		
	def update(self):
		delList = []
		for particle in self.particles:
			if particle.update():
				delList.append(particle)
		for particle in delList:
			self.particles.remove(particle)
		if not len(self.particles):
			return True
		return False
	def draw(self):
		for particle in self.particles:
			particle.draw()