from constants import *

from pyglet import options
options['debug_gl'] = not RELEASE


from pyglet import window
from pyglet import clock
from pyglet import media
from pyglet.window import key
from pyglet.gl import *
from pyglet.window import mouse


import RWorld
			
def main():
	#win = window.Window(800, 600, vsync = False)
	win = window.Window(800, 600)
	
	win.on_resize = initOGL
	
	keys = key.KeyStateHandler()
	win.push_handlers(keys)
	
	fps_display = clock.ClockDisplay()
	
	world = RWorld.World()
	
	t = 0
	iTick = 0
	
	win.on_mouse_press = world.click
	win.on_key_press = world.press
	clock.set_fps_limit(30)

	bEnd = False
	while not win.has_exit and not bEnd:
		win.clear()
		win.dispatch_events()
		media.dispatch_events()
		
		bUpdate = False
		while t > 1.0 / 30.0:
			if world.update(keys):
				bEnd = True
			t -= 1.0 / 30.0
			bUpdate = True
		if bUpdate:
			world.draw()
		
			if not RELEASE:
				fps_display.draw()
			
			win.flip()
		
		t += clock.tick()
		iTick += 1

		
def initOGL(width, height):
	glClearColor(*GROUND_COLOR)
	glDisable(GL_DEPTH_TEST)
	glClear(GL_COLOR_BUFFER_BIT)
	glEnable(GL_BLEND)
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glShadeModel(GL_SMOOTH)
	
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE)
	
	glEnable(GL_LINE_SMOOTH)
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST)
	
	glEnable(GL_POINT_SMOOTH)
	glHint(GL_POINT_SMOOTH_HINT, GL_NICEST)	
	
	#glPixelStorei(GL_UNPACK_ALIGNMENT, 1)
	
	glViewport(0, 0, width, height)
	glMatrixMode(GL_PROJECTION)
	glLoadIdentity()
	glOrtho(0, width, 0, height, -600, 600)
	# glMultTransposeMatrixf((GLfloat * 32)(1, 0, 0, 0,
						   # 0, 1, 0, 0,
						   # 0, 0, 1, -0.001,
						   # 0, 0, -0.001, 1))

	
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
	glTranslatef(400, 300, 0)
	glRotatef(180, 0, 0, 1)
	glTranslatef(-400, -300, 0)
			
# def main():
	# import data
	# dispSurf = pygame.display.set_mode((800, 600))
	
	# robot = pygame.image.load(data.filepath("robot.png")).convert_alpha()

	# leftTrack = pygame.image.load(data.filepath("leftTrack.png")).convert_alpha()
	# rightTrack = pygame.image.load(data.filepath("rightTrack.png")).convert_alpha()

	# clock = pygame.time.Clock()

	# leftTrackPos = 0
	# rightTrackPos = 0

	# while 1:
		# for event in pygame.event.get():
			# if event.type == pygame.KEYDOWN:
				# quit()

		# dispSurf.fill((128, 255, 128))
		
		# robotSurf = pygame.Surface((128, 114)).convert()
		# robotSurf.fill((0, 255, 255))
		# robotSurf.set_colorkey((0, 255, 255))
		
		# robotSurf.blit(leftTrack, (-leftTrackPos, 0))
		# robotSurf.blit(rightTrack, (-rightTrackPos, 0))		
		# robotSurf.blit(robot, (0, 0))
		
		# dispSurf.blit(robotSurf, (0, 0))
			
		# leftTrackPos += 1
		# rightTrackPos -= 1
		# leftTrackPos %= 12
		# rightTrackPos %= 12
		
		# print clock.tick()
				
		# pygame.display.flip()